/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|*  * AVR Disassembler                                                        *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/


#include "llvm/MC/MCInst.h"
#include "llvm/MC/MCSubtargetInfo.h"
#include "llvm/Support/DataTypes.h"
#include "llvm/Support/Debug.h"
#include "llvm/Support/LEB128.h"
#include "llvm/Support/raw_ostream.h"
#include "llvm/TargetParser/SubtargetFeature.h"
#include <assert.h>

namespace {

// Helper functions for extracting fields from encoded instructions.
// InsnType must either be integral or an APInt-like object that must:
// * be default-constructible and copy-constructible
// * be constructible from an APInt (this can be private)
// * Support insertBits(bits, startBit, numBits)
// * Support extractBitsAsZExtValue(numBits, startBit)
// * Support the ~, &, ==, and != operators with other objects of the same type
// * Support the != and bitwise & with uint64_t
// * Support put (<<) to raw_ostream&
template <typename InsnType>
#if defined(_MSC_VER) && !defined(__clang__)
__declspec(noinline)
#endif
static std::enable_if_t<std::is_integral<InsnType>::value, InsnType>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  assert(startBit + numBits <= 64 && "Cannot support >64-bit extractions!");
  assert(startBit + numBits <= (sizeof(InsnType) * 8) &&
         "Instruction field out of bounds!");
  InsnType fieldMask;
  if (numBits == sizeof(InsnType) * 8)
    fieldMask = (InsnType)(-1LL);
  else
    fieldMask = (((InsnType)1 << numBits) - 1) << startBit;
  return (insn & fieldMask) >> startBit;
}

template <typename InsnType>
static std::enable_if_t<!std::is_integral<InsnType>::value, uint64_t>
fieldFromInstruction(const InsnType &insn, unsigned startBit,
                     unsigned numBits) {
  return insn.extractBitsAsZExtValue(numBits, startBit);
}

// Helper function for inserting bits extracted from an encoded instruction into
// a field.
template <typename InsnType>
static void insertBits(InsnType &field, InsnType bits, unsigned startBit,
                       unsigned numBits) {
  if constexpr (std::is_integral<InsnType>::value) {
    assert(startBit + numBits <= sizeof field * 8);
    field |= (InsnType)bits << startBit;
  } else {
    field.insertBits(bits, startBit, numBits);
  }
}

static bool Check(DecodeStatus &Out, DecodeStatus In) {
  Out = static_cast<DecodeStatus>(Out & In);
  return Out != MCDisassembler::Fail;
}

static const uint8_t DecoderTable16[] = {
/* 0 */       MCD::OPC_ExtractField, 14, 2,  // Inst{15-14} ...
/* 3 */       MCD::OPC_FilterValue, 0, 229, 0, // Skip to: 236
/* 7 */       MCD::OPC_ExtractField, 12, 2,  // Inst{13-12} ...
/* 10 */      MCD::OPC_FilterValue, 0, 136, 0, // Skip to: 150
/* 14 */      MCD::OPC_ExtractField, 10, 2,  // Inst{11-10} ...
/* 17 */      MCD::OPC_FilterValue, 0, 105, 0, // Skip to: 126
/* 21 */      MCD::OPC_ExtractField, 8, 2,  // Inst{9-8} ...
/* 24 */      MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 38
/* 28 */      MCD::OPC_CheckField, 0, 8, 0, 139, 4, // Skip to: 1197
/* 34 */      MCD::OPC_Decode, 211, 3, 0, // Opcode: NOP
/* 38 */      MCD::OPC_FilterValue, 1, 8, 0, // Skip to: 50
/* 42 */      MCD::OPC_CheckPredicate, 0, 127, 4, // Skip to: 1197
/* 46 */      MCD::OPC_Decode, 206, 3, 1, // Opcode: MOVWRdRr
/* 50 */      MCD::OPC_FilterValue, 2, 8, 0, // Skip to: 62
/* 54 */      MCD::OPC_CheckPredicate, 1, 115, 4, // Skip to: 1197
/* 58 */      MCD::OPC_Decode, 208, 3, 2, // Opcode: MULSRdRr
/* 62 */      MCD::OPC_FilterValue, 3, 107, 4, // Skip to: 1197
/* 66 */      MCD::OPC_ExtractField, 3, 1,  // Inst{3} ...
/* 69 */      MCD::OPC_FilterValue, 0, 14, 0, // Skip to: 87
/* 73 */      MCD::OPC_CheckPredicate, 1, 41, 0, // Skip to: 118
/* 77 */      MCD::OPC_CheckField, 7, 1, 1, 35, 0, // Skip to: 118
/* 83 */      MCD::OPC_Decode, 184, 3, 3, // Opcode: FMULS
/* 87 */      MCD::OPC_FilterValue, 1, 27, 0, // Skip to: 118
/* 91 */      MCD::OPC_ExtractField, 7, 1,  // Inst{7} ...
/* 94 */      MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 106
/* 98 */      MCD::OPC_CheckPredicate, 1, 16, 0, // Skip to: 118
/* 102 */     MCD::OPC_Decode, 183, 3, 3, // Opcode: FMUL
/* 106 */     MCD::OPC_FilterValue, 1, 8, 0, // Skip to: 118
/* 110 */     MCD::OPC_CheckPredicate, 1, 4, 0, // Skip to: 118
/* 114 */     MCD::OPC_Decode, 185, 3, 3, // Opcode: FMULSU
/* 118 */     MCD::OPC_CheckPredicate, 1, 51, 4, // Skip to: 1197
/* 122 */     MCD::OPC_Decode, 209, 3, 2, // Opcode: MULSURdRr
/* 126 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 134
/* 130 */     MCD::OPC_Decode, 171, 3, 4, // Opcode: CPCRdRr
/* 134 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 142
/* 138 */     MCD::OPC_Decode, 223, 3, 5, // Opcode: SBCRdRr
/* 142 */     MCD::OPC_FilterValue, 3, 27, 4, // Skip to: 1197
/* 146 */     MCD::OPC_Decode, 148, 3, 5, // Opcode: ADDRdRr
/* 150 */     MCD::OPC_FilterValue, 1, 35, 0, // Skip to: 189
/* 154 */     MCD::OPC_ExtractField, 10, 2,  // Inst{11-10} ...
/* 157 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 165
/* 161 */     MCD::OPC_Decode, 174, 3, 4, // Opcode: CPSE
/* 165 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 173
/* 169 */     MCD::OPC_Decode, 173, 3, 4, // Opcode: CPRdRr
/* 173 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 181
/* 177 */     MCD::OPC_Decode, 240, 3, 5, // Opcode: SUBRdRr
/* 181 */     MCD::OPC_FilterValue, 3, 244, 3, // Skip to: 1197
/* 185 */     MCD::OPC_Decode, 147, 3, 5, // Opcode: ADCRdRr
/* 189 */     MCD::OPC_FilterValue, 2, 35, 0, // Skip to: 228
/* 193 */     MCD::OPC_ExtractField, 10, 2,  // Inst{11-10} ...
/* 196 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 204
/* 200 */     MCD::OPC_Decode, 151, 3, 5, // Opcode: ANDRdRr
/* 204 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 212
/* 208 */     MCD::OPC_Decode, 182, 3, 5, // Opcode: EORRdRr
/* 212 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 220
/* 216 */     MCD::OPC_Decode, 213, 3, 5, // Opcode: ORRdRr
/* 220 */     MCD::OPC_FilterValue, 3, 205, 3, // Skip to: 1197
/* 224 */     MCD::OPC_Decode, 205, 3, 4, // Opcode: MOVRdRr
/* 228 */     MCD::OPC_FilterValue, 3, 197, 3, // Skip to: 1197
/* 232 */     MCD::OPC_Decode, 172, 3, 6, // Opcode: CPIRdK
/* 236 */     MCD::OPC_FilterValue, 1, 35, 0, // Skip to: 275
/* 240 */     MCD::OPC_ExtractField, 12, 2,  // Inst{13-12} ...
/* 243 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 251
/* 247 */     MCD::OPC_Decode, 222, 3, 7, // Opcode: SBCIRdK
/* 251 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 259
/* 255 */     MCD::OPC_Decode, 239, 3, 7, // Opcode: SUBIRdK
/* 259 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 267
/* 263 */     MCD::OPC_Decode, 212, 3, 7, // Opcode: ORIRdK
/* 267 */     MCD::OPC_FilterValue, 3, 158, 3, // Skip to: 1197
/* 271 */     MCD::OPC_Decode, 150, 3, 7, // Opcode: ANDIRdK
/* 275 */     MCD::OPC_FilterValue, 2, 212, 2, // Skip to: 1003
/* 279 */     MCD::OPC_ExtractField, 12, 1,  // Inst{12} ...
/* 282 */     MCD::OPC_FilterValue, 0, 177, 0, // Skip to: 463
/* 286 */     MCD::OPC_ExtractField, 9, 1,  // Inst{9} ...
/* 289 */     MCD::OPC_FilterValue, 0, 83, 0, // Skip to: 376
/* 293 */     MCD::OPC_ExtractField, 0, 2,  // Inst{1-0} ...
/* 296 */     MCD::OPC_FilterValue, 0, 20, 0, // Skip to: 320
/* 300 */     MCD::OPC_CheckPredicate, 2, 64, 0, // Skip to: 368
/* 304 */     MCD::OPC_CheckField, 13, 1, 0, 58, 0, // Skip to: 368
/* 310 */     MCD::OPC_CheckField, 10, 2, 0, 52, 0, // Skip to: 368
/* 316 */     MCD::OPC_Decode, 196, 3, 8, // Opcode: LDRdPtr
/* 320 */     MCD::OPC_FilterValue, 1, 20, 0, // Skip to: 344
/* 324 */     MCD::OPC_CheckPredicate, 2, 40, 0, // Skip to: 368
/* 328 */     MCD::OPC_CheckField, 13, 1, 0, 34, 0, // Skip to: 368
/* 334 */     MCD::OPC_CheckField, 10, 2, 0, 28, 0, // Skip to: 368
/* 340 */     MCD::OPC_Decode, 198, 3, 8, // Opcode: LDRdPtrPi
/* 344 */     MCD::OPC_FilterValue, 2, 20, 0, // Skip to: 368
/* 348 */     MCD::OPC_CheckPredicate, 2, 16, 0, // Skip to: 368
/* 352 */     MCD::OPC_CheckField, 13, 1, 0, 10, 0, // Skip to: 368
/* 358 */     MCD::OPC_CheckField, 10, 2, 0, 4, 0, // Skip to: 368
/* 364 */     MCD::OPC_Decode, 197, 3, 8, // Opcode: LDRdPtrPd
/* 368 */     MCD::OPC_CheckPredicate, 3, 57, 3, // Skip to: 1197
/* 372 */     MCD::OPC_Decode, 194, 3, 9, // Opcode: LDDRdPtrQ
/* 376 */     MCD::OPC_FilterValue, 1, 49, 3, // Skip to: 1197
/* 380 */     MCD::OPC_ExtractField, 0, 2,  // Inst{1-0} ...
/* 383 */     MCD::OPC_FilterValue, 0, 20, 0, // Skip to: 407
/* 387 */     MCD::OPC_CheckPredicate, 2, 64, 0, // Skip to: 455
/* 391 */     MCD::OPC_CheckField, 13, 1, 0, 58, 0, // Skip to: 455
/* 397 */     MCD::OPC_CheckField, 10, 2, 0, 52, 0, // Skip to: 455
/* 403 */     MCD::OPC_Decode, 236, 3, 8, // Opcode: STPtrRr
/* 407 */     MCD::OPC_FilterValue, 1, 20, 0, // Skip to: 431
/* 411 */     MCD::OPC_CheckPredicate, 2, 40, 0, // Skip to: 455
/* 415 */     MCD::OPC_CheckField, 13, 1, 0, 34, 0, // Skip to: 455
/* 421 */     MCD::OPC_CheckField, 10, 2, 0, 28, 0, // Skip to: 455
/* 427 */     MCD::OPC_Decode, 235, 3, 8, // Opcode: STPtrPiRr
/* 431 */     MCD::OPC_FilterValue, 2, 20, 0, // Skip to: 455
/* 435 */     MCD::OPC_CheckPredicate, 2, 16, 0, // Skip to: 455
/* 439 */     MCD::OPC_CheckField, 13, 1, 0, 10, 0, // Skip to: 455
/* 445 */     MCD::OPC_CheckField, 10, 2, 0, 4, 0, // Skip to: 455
/* 451 */     MCD::OPC_Decode, 234, 3, 8, // Opcode: STPtrPdRr
/* 455 */     MCD::OPC_CheckPredicate, 3, 226, 2, // Skip to: 1197
/* 459 */     MCD::OPC_Decode, 233, 3, 10, // Opcode: STDPtrQRr
/* 463 */     MCD::OPC_FilterValue, 1, 218, 2, // Skip to: 1197
/* 467 */     MCD::OPC_ExtractField, 11, 1,  // Inst{11} ...
/* 470 */     MCD::OPC_FilterValue, 0, 200, 1, // Skip to: 930
/* 474 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 477 */     MCD::OPC_FilterValue, 0, 185, 1, // Skip to: 922
/* 481 */     MCD::OPC_ExtractField, 9, 2,  // Inst{10-9} ...
/* 484 */     MCD::OPC_FilterValue, 0, 63, 0, // Skip to: 551
/* 488 */     MCD::OPC_ExtractField, 0, 4,  // Inst{3-0} ...
/* 491 */     MCD::OPC_FilterValue, 4, 8, 0, // Skip to: 503
/* 495 */     MCD::OPC_CheckPredicate, 4, 186, 2, // Skip to: 1197
/* 499 */     MCD::OPC_Decode, 202, 3, 11, // Opcode: LPMRdZ
/* 503 */     MCD::OPC_FilterValue, 5, 8, 0, // Skip to: 515
/* 507 */     MCD::OPC_CheckPredicate, 4, 174, 2, // Skip to: 1197
/* 511 */     MCD::OPC_Decode, 203, 3, 11, // Opcode: LPMRdZPi
/* 515 */     MCD::OPC_FilterValue, 6, 8, 0, // Skip to: 527
/* 519 */     MCD::OPC_CheckPredicate, 5, 162, 2, // Skip to: 1197
/* 523 */     MCD::OPC_Decode, 180, 3, 11, // Opcode: ELPMRdZ
/* 527 */     MCD::OPC_FilterValue, 7, 8, 0, // Skip to: 539
/* 531 */     MCD::OPC_CheckPredicate, 5, 150, 2, // Skip to: 1197
/* 535 */     MCD::OPC_Decode, 181, 3, 11, // Opcode: ELPMRdZPi
/* 539 */     MCD::OPC_FilterValue, 15, 142, 2, // Skip to: 1197
/* 543 */     MCD::OPC_CheckPredicate, 2, 138, 2, // Skip to: 1197
/* 547 */     MCD::OPC_Decode, 215, 3, 12, // Opcode: POPRd
/* 551 */     MCD::OPC_FilterValue, 1, 63, 0, // Skip to: 618
/* 555 */     MCD::OPC_ExtractField, 0, 4,  // Inst{3-0} ...
/* 558 */     MCD::OPC_FilterValue, 4, 8, 0, // Skip to: 570
/* 562 */     MCD::OPC_CheckPredicate, 6, 119, 2, // Skip to: 1197
/* 566 */     MCD::OPC_Decode, 243, 3, 13, // Opcode: XCHZRd
/* 570 */     MCD::OPC_FilterValue, 5, 8, 0, // Skip to: 582
/* 574 */     MCD::OPC_CheckPredicate, 6, 107, 2, // Skip to: 1197
/* 578 */     MCD::OPC_Decode, 192, 3, 13, // Opcode: LASZRd
/* 582 */     MCD::OPC_FilterValue, 6, 8, 0, // Skip to: 594
/* 586 */     MCD::OPC_CheckPredicate, 6, 95, 2, // Skip to: 1197
/* 590 */     MCD::OPC_Decode, 191, 3, 13, // Opcode: LACZRd
/* 594 */     MCD::OPC_FilterValue, 7, 8, 0, // Skip to: 606
/* 598 */     MCD::OPC_CheckPredicate, 6, 83, 2, // Skip to: 1197
/* 602 */     MCD::OPC_Decode, 193, 3, 13, // Opcode: LATZRd
/* 606 */     MCD::OPC_FilterValue, 15, 75, 2, // Skip to: 1197
/* 610 */     MCD::OPC_CheckPredicate, 2, 71, 2, // Skip to: 1197
/* 614 */     MCD::OPC_Decode, 216, 3, 12, // Opcode: PUSHRr
/* 618 */     MCD::OPC_FilterValue, 2, 13, 1, // Skip to: 891
/* 622 */     MCD::OPC_ExtractField, 0, 4,  // Inst{3-0} ...
/* 625 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 633
/* 629 */     MCD::OPC_Decode, 170, 3, 12, // Opcode: COMRd
/* 633 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 641
/* 637 */     MCD::OPC_Decode, 210, 3, 12, // Opcode: NEGRd
/* 641 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 649
/* 645 */     MCD::OPC_Decode, 241, 3, 12, // Opcode: SWAPRd
/* 649 */     MCD::OPC_FilterValue, 3, 4, 0, // Skip to: 657
/* 653 */     MCD::OPC_Decode, 188, 3, 12, // Opcode: INCRd
/* 657 */     MCD::OPC_FilterValue, 5, 4, 0, // Skip to: 665
/* 661 */     MCD::OPC_Decode, 152, 3, 12, // Opcode: ASRRd
/* 665 */     MCD::OPC_FilterValue, 6, 4, 0, // Skip to: 673
/* 669 */     MCD::OPC_Decode, 204, 3, 12, // Opcode: LSRRd
/* 673 */     MCD::OPC_FilterValue, 7, 4, 0, // Skip to: 681
/* 677 */     MCD::OPC_Decode, 221, 3, 12, // Opcode: RORRd
/* 681 */     MCD::OPC_FilterValue, 8, 125, 0, // Skip to: 810
/* 685 */     MCD::OPC_ExtractField, 7, 2,  // Inst{8-7} ...
/* 688 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 696
/* 692 */     MCD::OPC_Decode, 166, 3, 14, // Opcode: BSETs
/* 696 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 704
/* 700 */     MCD::OPC_Decode, 153, 3, 14, // Opcode: BCLRs
/* 704 */     MCD::OPC_FilterValue, 2, 19, 0, // Skip to: 727
/* 708 */     MCD::OPC_ExtractField, 4, 3,  // Inst{6-4} ...
/* 711 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 719
/* 715 */     MCD::OPC_Decode, 218, 3, 0, // Opcode: RET
/* 719 */     MCD::OPC_FilterValue, 1, 218, 1, // Skip to: 1197
/* 723 */     MCD::OPC_Decode, 219, 3, 0, // Opcode: RETI
/* 727 */     MCD::OPC_FilterValue, 3, 210, 1, // Skip to: 1197
/* 731 */     MCD::OPC_ExtractField, 4, 3,  // Inst{6-4} ...
/* 734 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 742
/* 738 */     MCD::OPC_Decode, 230, 3, 0, // Opcode: SLEEP
/* 742 */     MCD::OPC_FilterValue, 1, 8, 0, // Skip to: 754
/* 746 */     MCD::OPC_CheckPredicate, 7, 191, 1, // Skip to: 1197
/* 750 */     MCD::OPC_Decode, 157, 3, 0, // Opcode: BREAK
/* 754 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 762
/* 758 */     MCD::OPC_Decode, 242, 3, 0, // Opcode: WDR
/* 762 */     MCD::OPC_FilterValue, 4, 8, 0, // Skip to: 774
/* 766 */     MCD::OPC_CheckPredicate, 8, 171, 1, // Skip to: 1197
/* 770 */     MCD::OPC_Decode, 201, 3, 0, // Opcode: LPM
/* 774 */     MCD::OPC_FilterValue, 5, 8, 0, // Skip to: 786
/* 778 */     MCD::OPC_CheckPredicate, 9, 159, 1, // Skip to: 1197
/* 782 */     MCD::OPC_Decode, 179, 3, 0, // Opcode: ELPM
/* 786 */     MCD::OPC_FilterValue, 6, 8, 0, // Skip to: 798
/* 790 */     MCD::OPC_CheckPredicate, 10, 147, 1, // Skip to: 1197
/* 794 */     MCD::OPC_Decode, 231, 3, 0, // Opcode: SPM
/* 798 */     MCD::OPC_FilterValue, 7, 139, 1, // Skip to: 1197
/* 802 */     MCD::OPC_CheckPredicate, 11, 135, 1, // Skip to: 1197
/* 806 */     MCD::OPC_Decode, 232, 3, 0, // Opcode: SPMZPi
/* 810 */     MCD::OPC_FilterValue, 9, 51, 0, // Skip to: 865
/* 814 */     MCD::OPC_ExtractField, 4, 5,  // Inst{8-4} ...
/* 817 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 829
/* 821 */     MCD::OPC_CheckPredicate, 12, 116, 1, // Skip to: 1197
/* 825 */     MCD::OPC_Decode, 187, 3, 0, // Opcode: IJMP
/* 829 */     MCD::OPC_FilterValue, 1, 8, 0, // Skip to: 841
/* 833 */     MCD::OPC_CheckPredicate, 13, 104, 1, // Skip to: 1197
/* 837 */     MCD::OPC_Decode, 178, 3, 0, // Opcode: EIJMP
/* 841 */     MCD::OPC_FilterValue, 16, 8, 0, // Skip to: 853
/* 845 */     MCD::OPC_CheckPredicate, 12, 92, 1, // Skip to: 1197
/* 849 */     MCD::OPC_Decode, 186, 3, 0, // Opcode: ICALL
/* 853 */     MCD::OPC_FilterValue, 17, 84, 1, // Skip to: 1197
/* 857 */     MCD::OPC_CheckPredicate, 13, 80, 1, // Skip to: 1197
/* 861 */     MCD::OPC_Decode, 177, 3, 0, // Opcode: EICALL
/* 865 */     MCD::OPC_FilterValue, 10, 4, 0, // Skip to: 873
/* 869 */     MCD::OPC_Decode, 175, 3, 12, // Opcode: DECRd
/* 873 */     MCD::OPC_FilterValue, 11, 64, 1, // Skip to: 1197
/* 877 */     MCD::OPC_CheckPredicate, 14, 60, 1, // Skip to: 1197
/* 881 */     MCD::OPC_CheckField, 8, 1, 0, 54, 1, // Skip to: 1197
/* 887 */     MCD::OPC_Decode, 176, 3, 15, // Opcode: DESK
/* 891 */     MCD::OPC_FilterValue, 3, 46, 1, // Skip to: 1197
/* 895 */     MCD::OPC_ExtractField, 8, 1,  // Inst{8} ...
/* 898 */     MCD::OPC_FilterValue, 0, 8, 0, // Skip to: 910
/* 902 */     MCD::OPC_CheckPredicate, 15, 35, 1, // Skip to: 1197
/* 906 */     MCD::OPC_Decode, 149, 3, 16, // Opcode: ADIWRdK
/* 910 */     MCD::OPC_FilterValue, 1, 27, 1, // Skip to: 1197
/* 914 */     MCD::OPC_CheckPredicate, 15, 23, 1, // Skip to: 1197
/* 918 */     MCD::OPC_Decode, 227, 3, 16, // Opcode: SBIWRdK
/* 922 */     MCD::OPC_FilterValue, 1, 15, 1, // Skip to: 1197
/* 926 */     MCD::OPC_Decode, 189, 3, 17, // Opcode: INRdA
/* 930 */     MCD::OPC_FilterValue, 1, 7, 1, // Skip to: 1197
/* 934 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 937 */     MCD::OPC_FilterValue, 0, 54, 0, // Skip to: 995
/* 941 */     MCD::OPC_ExtractField, 10, 1,  // Inst{10} ...
/* 944 */     MCD::OPC_FilterValue, 0, 35, 0, // Skip to: 983
/* 948 */     MCD::OPC_ExtractField, 8, 2,  // Inst{9-8} ...
/* 951 */     MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 959
/* 955 */     MCD::OPC_Decode, 169, 3, 18, // Opcode: CBIAb
/* 959 */     MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 967
/* 963 */     MCD::OPC_Decode, 225, 3, 18, // Opcode: SBICAb
/* 967 */     MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 975
/* 971 */     MCD::OPC_Decode, 224, 3, 18, // Opcode: SBIAb
/* 975 */     MCD::OPC_FilterValue, 3, 218, 0, // Skip to: 1197
/* 979 */     MCD::OPC_Decode, 226, 3, 18, // Opcode: SBISAb
/* 983 */     MCD::OPC_FilterValue, 1, 210, 0, // Skip to: 1197
/* 987 */     MCD::OPC_CheckPredicate, 1, 206, 0, // Skip to: 1197
/* 991 */     MCD::OPC_Decode, 207, 3, 4, // Opcode: MULRdRr
/* 995 */     MCD::OPC_FilterValue, 1, 198, 0, // Skip to: 1197
/* 999 */     MCD::OPC_Decode, 214, 3, 19, // Opcode: OUTARr
/* 1003 */    MCD::OPC_FilterValue, 3, 190, 0, // Skip to: 1197
/* 1007 */    MCD::OPC_ExtractField, 12, 2,  // Inst{13-12} ...
/* 1010 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 1018
/* 1014 */    MCD::OPC_Decode, 220, 3, 20, // Opcode: RJMPk
/* 1018 */    MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 1026
/* 1022 */    MCD::OPC_Decode, 217, 3, 20, // Opcode: RCALLk
/* 1026 */    MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 1034
/* 1030 */    MCD::OPC_Decode, 195, 3, 6, // Opcode: LDIRdK
/* 1034 */    MCD::OPC_FilterValue, 3, 159, 0, // Skip to: 1197
/* 1038 */    MCD::OPC_ExtractField, 10, 2,  // Inst{11-10} ...
/* 1041 */    MCD::OPC_FilterValue, 0, 39, 0, // Skip to: 1084
/* 1045 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 1048 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 1056
/* 1052 */    MCD::OPC_Decode, 160, 3, 21, // Opcode: BRLOk
/* 1056 */    MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 1064
/* 1060 */    MCD::OPC_Decode, 158, 3, 21, // Opcode: BREQk
/* 1064 */    MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 1072
/* 1068 */    MCD::OPC_Decode, 162, 3, 21, // Opcode: BRMIk
/* 1072 */    MCD::OPC_FilterValue, 4, 4, 0, // Skip to: 1080
/* 1076 */    MCD::OPC_Decode, 161, 3, 21, // Opcode: BRLTk
/* 1080 */    MCD::OPC_Decode, 156, 3, 21, // Opcode: BRBSsk
/* 1084 */    MCD::OPC_FilterValue, 1, 39, 0, // Skip to: 1127
/* 1088 */    MCD::OPC_ExtractField, 0, 3,  // Inst{2-0} ...
/* 1091 */    MCD::OPC_FilterValue, 0, 4, 0, // Skip to: 1099
/* 1095 */    MCD::OPC_Decode, 165, 3, 21, // Opcode: BRSHk
/* 1099 */    MCD::OPC_FilterValue, 1, 4, 0, // Skip to: 1107
/* 1103 */    MCD::OPC_Decode, 163, 3, 21, // Opcode: BRNEk
/* 1107 */    MCD::OPC_FilterValue, 2, 4, 0, // Skip to: 1115
/* 1111 */    MCD::OPC_Decode, 164, 3, 21, // Opcode: BRPLk
/* 1115 */    MCD::OPC_FilterValue, 4, 4, 0, // Skip to: 1123
/* 1119 */    MCD::OPC_Decode, 159, 3, 21, // Opcode: BRGEk
/* 1123 */    MCD::OPC_Decode, 155, 3, 21, // Opcode: BRBCsk
/* 1127 */    MCD::OPC_FilterValue, 2, 31, 0, // Skip to: 1162
/* 1131 */    MCD::OPC_ExtractField, 9, 1,  // Inst{9} ...
/* 1134 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1148
/* 1138 */    MCD::OPC_CheckField, 3, 1, 0, 53, 0, // Skip to: 1197
/* 1144 */    MCD::OPC_Decode, 154, 3, 22, // Opcode: BLD
/* 1148 */    MCD::OPC_FilterValue, 1, 45, 0, // Skip to: 1197
/* 1152 */    MCD::OPC_CheckField, 3, 1, 0, 39, 0, // Skip to: 1197
/* 1158 */    MCD::OPC_Decode, 167, 3, 23, // Opcode: BST
/* 1162 */    MCD::OPC_FilterValue, 3, 31, 0, // Skip to: 1197
/* 1166 */    MCD::OPC_ExtractField, 9, 1,  // Inst{9} ...
/* 1169 */    MCD::OPC_FilterValue, 0, 10, 0, // Skip to: 1183
/* 1173 */    MCD::OPC_CheckField, 3, 1, 0, 18, 0, // Skip to: 1197
/* 1179 */    MCD::OPC_Decode, 228, 3, 23, // Opcode: SBRCRrB
/* 1183 */    MCD::OPC_FilterValue, 1, 10, 0, // Skip to: 1197
/* 1187 */    MCD::OPC_CheckField, 3, 1, 0, 4, 0, // Skip to: 1197
/* 1193 */    MCD::OPC_Decode, 229, 3, 23, // Opcode: SBRSRrB
/* 1197 */    MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTable32[] = {
/* 0 */       MCD::OPC_ExtractField, 17, 3,  // Inst{19-17} ...
/* 3 */       MCD::OPC_FilterValue, 0, 39, 0, // Skip to: 46
/* 7 */       MCD::OPC_ExtractField, 25, 7,  // Inst{31-25} ...
/* 10 */      MCD::OPC_FilterValue, 72, 14, 0, // Skip to: 28
/* 14 */      MCD::OPC_CheckPredicate, 3, 64, 0, // Skip to: 82
/* 18 */      MCD::OPC_CheckField, 16, 1, 0, 58, 0, // Skip to: 82
/* 24 */      MCD::OPC_Decode, 199, 3, 24, // Opcode: LDSRdK
/* 28 */      MCD::OPC_FilterValue, 73, 50, 0, // Skip to: 82
/* 32 */      MCD::OPC_CheckPredicate, 3, 46, 0, // Skip to: 82
/* 36 */      MCD::OPC_CheckField, 16, 1, 0, 40, 0, // Skip to: 82
/* 42 */      MCD::OPC_Decode, 237, 3, 25, // Opcode: STSKRr
/* 46 */      MCD::OPC_FilterValue, 6, 14, 0, // Skip to: 64
/* 50 */      MCD::OPC_CheckPredicate, 16, 28, 0, // Skip to: 82
/* 54 */      MCD::OPC_CheckField, 25, 7, 74, 22, 0, // Skip to: 82
/* 60 */      MCD::OPC_Decode, 190, 3, 26, // Opcode: JMPk
/* 64 */      MCD::OPC_FilterValue, 7, 14, 0, // Skip to: 82
/* 68 */      MCD::OPC_CheckPredicate, 16, 10, 0, // Skip to: 82
/* 72 */      MCD::OPC_CheckField, 25, 7, 74, 4, 0, // Skip to: 82
/* 78 */      MCD::OPC_Decode, 168, 3, 26, // Opcode: CALLk
/* 82 */      MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableAVRTiny16[] = {
/* 0 */       MCD::OPC_ExtractField, 11, 5,  // Inst{15-11} ...
/* 3 */       MCD::OPC_FilterValue, 20, 8, 0, // Skip to: 15
/* 7 */       MCD::OPC_CheckPredicate, 17, 16, 0, // Skip to: 27
/* 11 */      MCD::OPC_Decode, 200, 3, 27, // Opcode: LDSRdKTiny
/* 15 */      MCD::OPC_FilterValue, 21, 8, 0, // Skip to: 27
/* 19 */      MCD::OPC_CheckPredicate, 17, 4, 0, // Skip to: 27
/* 23 */      MCD::OPC_Decode, 238, 3, 28, // Opcode: STSKRrTiny
/* 27 */      MCD::OPC_Fail,
  0
};

static bool checkDecoderPredicate(unsigned Idx, const FeatureBitset &Bits) {
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    return (Bits[AVR::FeatureMOVW]);
  case 1:
    return (Bits[AVR::FeatureMultiplication]);
  case 2:
    return (Bits[AVR::FeatureSRAM]);
  case 3:
    return (Bits[AVR::FeatureSRAM] && !Bits[AVR::FeatureTinyEncoding]);
  case 4:
    return (Bits[AVR::FeatureLPMX]);
  case 5:
    return (Bits[AVR::FeatureELPMX]);
  case 6:
    return (Bits[AVR::FeatureRMW]);
  case 7:
    return (Bits[AVR::FeatureBREAK]);
  case 8:
    return (Bits[AVR::FeatureLPM]);
  case 9:
    return (Bits[AVR::FeatureELPM]);
  case 10:
    return (Bits[AVR::FeatureSPM]);
  case 11:
    return (Bits[AVR::FeatureSPMX]);
  case 12:
    return (Bits[AVR::FeatureIJMPCALL]);
  case 13:
    return (Bits[AVR::FeatureEIJMPCALL]);
  case 14:
    return (Bits[AVR::FeatureDES]);
  case 15:
    return (Bits[AVR::FeatureADDSUBIW]);
  case 16:
    return (Bits[AVR::FeatureJMPCALL]);
  case 17:
    return (Bits[AVR::FeatureSRAM] && Bits[AVR::FeatureTinyEncoding]);
  }
}

template <typename InsnType>
static DecodeStatus decodeToMCInst(DecodeStatus S, unsigned Idx, InsnType insn, MCInst &MI,
                                   uint64_t Address, const MCDisassembler *Decoder, bool &DecodeComplete) {
  DecodeComplete = true;
  using TmpType = std::conditional_t<std::is_integral<InsnType>::value, InsnType, uint64_t>;
  TmpType tmp;
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    return S;
  case 1:
    if (!Check(S, decodeFMOVWRdRr(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 2:
    if (!Check(S, decodeFMUL2RdRr(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 3:
    if (!Check(S, decodeFFMULRdRr(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 4:
    tmp = fieldFromInstruction(insn, 4, 5);
    if (!Check(S, DecodeGPR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 4), 0, 4);
    insertBits(tmp, fieldFromInstruction(insn, 9, 1), 4, 1);
    if (!Check(S, DecodeGPR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 5:
    tmp = fieldFromInstruction(insn, 4, 5);
    if (!Check(S, DecodeGPR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 4, 5);
    if (!Check(S, DecodeGPR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 4), 0, 4);
    insertBits(tmp, fieldFromInstruction(insn, 9, 1), 4, 1);
    if (!Check(S, DecodeGPR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 6:
    tmp = fieldFromInstruction(insn, 4, 4);
    if (!Check(S, DecodeLD8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 4), 0, 4);
    insertBits(tmp, fieldFromInstruction(insn, 8, 4), 4, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 7:
    tmp = fieldFromInstruction(insn, 4, 4);
    if (!Check(S, DecodeLD8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 4, 4);
    if (!Check(S, DecodeLD8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 4), 0, 4);
    insertBits(tmp, fieldFromInstruction(insn, 8, 4), 4, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 8:
    if (!Check(S, decodeLoadStore(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 9:
    tmp = fieldFromInstruction(insn, 4, 5);
    if (!Check(S, DecodeGPR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 6, 1);
    insertBits(tmp, fieldFromInstruction(insn, 10, 2), 3, 2);
    insertBits(tmp, fieldFromInstruction(insn, 13, 1), 5, 1);
    if (!Check(S, decodeMemri(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 10:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 3), 0, 3);
    insertBits(tmp, fieldFromInstruction(insn, 3, 1), 6, 1);
    insertBits(tmp, fieldFromInstruction(insn, 10, 2), 3, 2);
    insertBits(tmp, fieldFromInstruction(insn, 13, 1), 5, 1);
    if (!Check(S, decodeMemri(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 4, 5);
    if (!Check(S, DecodeGPR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 11:
    if (!Check(S, decodeFLPMX(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 12:
    if (!Check(S, decodeFRd(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 13:
    tmp = fieldFromInstruction(insn, 4, 5);
    if (!Check(S, DecodeGPR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 14:
    tmp = fieldFromInstruction(insn, 4, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 15:
    tmp = fieldFromInstruction(insn, 4, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 16:
    if (!Check(S, decodeFWRdK(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 17:
    if (!Check(S, decodeFIORdA(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 18:
    if (!Check(S, decodeFIOBIT(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 19:
    if (!Check(S, decodeFIOARr(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 20:
    if (!Check(S, decodeFBRk(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 21:
    if (!Check(S, decodeCondBranch(MI, insn, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 22:
    tmp = fieldFromInstruction(insn, 4, 5);
    if (!Check(S, DecodeGPR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 4, 5);
    if (!Check(S, DecodeGPR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 23:
    tmp = fieldFromInstruction(insn, 4, 5);
    if (!Check(S, DecodeGPR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 24:
    tmp = fieldFromInstruction(insn, 20, 5);
    if (!Check(S, DecodeGPR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 25:
    tmp = fieldFromInstruction(insn, 0, 16);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 20, 5);
    if (!Check(S, DecodeGPR8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 26:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 17), 0, 17);
    insertBits(tmp, fieldFromInstruction(insn, 20, 5), 17, 5);
    if (!Check(S, decodeCallTarget(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  case 27:
    tmp = fieldFromInstruction(insn, 4, 4);
    if (!Check(S, DecodeLD8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 4), 0, 4);
    insertBits(tmp, fieldFromInstruction(insn, 8, 3), 4, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 28:
    tmp = 0x0;
    insertBits(tmp, fieldFromInstruction(insn, 0, 4), 0, 4);
    insertBits(tmp, fieldFromInstruction(insn, 8, 3), 4, 3);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 4, 4);
    if (!Check(S, DecodeLD8RegisterClass(MI, tmp, Address, Decoder))) { return MCDisassembler::Fail; }
    return S;
  }
}

static unsigned decodeNumToSkip(const uint8_t *&Ptr) {
  unsigned NumToSkip = *Ptr++;
  NumToSkip |= (*Ptr++) << 8;
  return NumToSkip;
}

template <typename InsnType>
static DecodeStatus decodeInstruction(const uint8_t DecodeTable[], MCInst &MI,
                                      InsnType insn, uint64_t Address,
                                      const MCDisassembler *DisAsm,
                                      const MCSubtargetInfo &STI) {
  const FeatureBitset &Bits = STI.getFeatureBits();

  const uint8_t *Ptr = DecodeTable;
  uint64_t CurFieldValue = 0;
  DecodeStatus S = MCDisassembler::Success;
  while (true) {
    ptrdiff_t Loc = Ptr - DecodeTable;
    switch (*Ptr++) {
    default:
      errs() << Loc << ": Unexpected decode table opcode!\n";
      return MCDisassembler::Fail;
    case MCD::OPC_ExtractField: {
      // Decode the start value.
      unsigned Start = decodeULEB128AndIncUnsafe(Ptr);
      unsigned Len = *Ptr++;
      CurFieldValue = fieldFromInstruction(insn, Start, Len);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_ExtractField(" << Start << ", "
                   << Len << "): " << CurFieldValue << "\n");
      break;
    }
    case MCD::OPC_FilterValue: {
      // Decode the field value.
      uint64_t Val = decodeULEB128AndIncUnsafe(Ptr);
      bool Failed = Val != CurFieldValue;
      unsigned NumToSkip = decodeNumToSkip(Ptr);

      // Perform the filter operation.
      if (Failed)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_FilterValue(" << Val << ", " << NumToSkip
                   << "): " << (Failed ? "FAIL:" : "PASS:")
                   << " continuing at " << (Ptr - DecodeTable) << "\n");

      break;
    }
    case MCD::OPC_CheckField: {
      // Decode the start value.
      unsigned Start = decodeULEB128AndIncUnsafe(Ptr);
      unsigned Len = *Ptr;
      uint64_t FieldValue = fieldFromInstruction(insn, Start, Len);
      // Decode the field value.
      unsigned PtrLen = 0;
      uint64_t ExpectedValue = decodeULEB128(++Ptr, &PtrLen);
      Ptr += PtrLen;
      bool Failed = ExpectedValue != FieldValue;
      unsigned NumToSkip = decodeNumToSkip(Ptr);

      // If the actual and expected values don't match, skip.
      if (Failed)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckField(" << Start << ", "
                   << Len << ", " << ExpectedValue << ", " << NumToSkip
                   << "): FieldValue = " << FieldValue << ", ExpectedValue = "
                   << ExpectedValue << ": "
                   << (Failed ? "FAIL\n" : "PASS\n"));
      break;
    }
    case MCD::OPC_CheckPredicate: {
      // Decode the Predicate Index value.
      unsigned PIdx = decodeULEB128AndIncUnsafe(Ptr);
      unsigned NumToSkip = decodeNumToSkip(Ptr);
      // Check the predicate.
      bool Failed = !checkDecoderPredicate(PIdx, Bits);
      if (Failed)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckPredicate(" << PIdx << "): "
            << (Failed ? "FAIL\n" : "PASS\n"));

      break;
    }
    case MCD::OPC_Decode: {
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128AndIncUnsafe(Ptr);
      unsigned DecodeIdx = decodeULEB128AndIncUnsafe(Ptr);

      MI.clear();
      MI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, MI, Address, DisAsm, DecodeComplete);
      assert(DecodeComplete);

      LLVM_DEBUG(dbgs() << Loc << ": OPC_Decode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": "
                   << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
      return S;
    }
    case MCD::OPC_TryDecode: {
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128AndIncUnsafe(Ptr);
      unsigned DecodeIdx = decodeULEB128AndIncUnsafe(Ptr);
      unsigned NumToSkip = decodeNumToSkip(Ptr);

      // Perform the decode operation.
      MCInst TmpMI;
      TmpMI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, TmpMI, Address, DisAsm, DecodeComplete);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_TryDecode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": ");

      if (DecodeComplete) {
        // Decoding complete.
        LLVM_DEBUG(dbgs() << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
        MI = TmpMI;
        return S;
      } else {
        assert(S == MCDisassembler::Fail);
        // If the decoding was incomplete, skip.
        Ptr += NumToSkip;
        LLVM_DEBUG(dbgs() << "FAIL: continuing at " << (Ptr - DecodeTable) << "\n");
        // Reset decode status. This also drops a SoftFail status that could be
        // set before the decode attempt.
        S = MCDisassembler::Success;
      }
      break;
    }
    case MCD::OPC_SoftFail: {
      // Decode the mask values.
      uint64_t PositiveMask = decodeULEB128AndIncUnsafe(Ptr);
      uint64_t NegativeMask = decodeULEB128AndIncUnsafe(Ptr);
      bool Fail = (insn & PositiveMask) != 0 || (~insn & NegativeMask) != 0;
      if (Fail)
        S = MCDisassembler::SoftFail;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_SoftFail: " << (Fail ? "FAIL\n" : "PASS\n"));
      break;
    }
    case MCD::OPC_Fail: {
      LLVM_DEBUG(dbgs() << Loc << ": OPC_Fail\n");
      return MCDisassembler::Fail;
    }
    }
  }
  llvm_unreachable("bogosity detected in disassembler state machine!");
}


} // namespace
