/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the BPF target                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 11;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(BPFInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(BPFInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static BPFInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static BPFInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s32,
  GILLT_s64,
};
const static size_t NumTypeObjects = 2;
const static LLT TypeObjects[] = {
  LLT::scalar(32),
  LLT::scalar(64),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_BPFIsLittleEndianBit = 7,
  Feature_BPFIsBigEndianBit = 8,
  Feature_BPFHasALU32Bit = 5,
  Feature_BPFNoALU32Bit = 2,
  Feature_BPFHasLdsxBit = 4,
  Feature_BPFHasMovsxBit = 1,
  Feature_BPFHasBswapBit = 6,
  Feature_BPFHasSdivSmodBit = 0,
  Feature_BPFNoMovsxBit = 10,
  Feature_BPFHasStoreImmBit = 3,
  Feature_BPFHasLoadAcqStoreRelBit = 9,
};

PredicateBitset BPFInstructionSelector::
computeAvailableModuleFeatures(const BPFSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->isLittleEndian())
    Features.set(Feature_BPFIsLittleEndianBit);
  if (!Subtarget->isLittleEndian())
    Features.set(Feature_BPFIsBigEndianBit);
  if (Subtarget->getHasAlu32())
    Features.set(Feature_BPFHasALU32Bit);
  if (!Subtarget->getHasAlu32())
    Features.set(Feature_BPFNoALU32Bit);
  if (Subtarget->hasLdsx())
    Features.set(Feature_BPFHasLdsxBit);
  if (Subtarget->hasMovsx())
    Features.set(Feature_BPFHasMovsxBit);
  if (Subtarget->hasBswap())
    Features.set(Feature_BPFHasBswapBit);
  if (Subtarget->hasSdivSmod())
    Features.set(Feature_BPFHasSdivSmodBit);
  if (!Subtarget->hasMovsx())
    Features.set(Feature_BPFNoMovsxBit);
  if (Subtarget->hasStoreImm())
    Features.set(Feature_BPFHasStoreImmBit);
  if (Subtarget->hasLoadAcqStoreRel())
    Features.set(Feature_BPFHasLoadAcqStoreRelBit);
  return Features;
}

void BPFInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const BPFSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset BPFInstructionSelector::
computeAvailableFunctionFeatures(const BPFSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_BPFHasBswap,
  GIFBS_BPFHasMovsx,
  GIFBS_BPFHasSdivSmod,
  GIFBS_BPFIsBigEndian,
  GIFBS_BPFIsLittleEndian,
  GIFBS_BPFNoMovsx,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_BPFHasBswapBit, },
  {Feature_BPFHasMovsxBit, },
  {Feature_BPFHasSdivSmodBit, },
  {Feature_BPFIsBigEndianBit, },
  {Feature_BPFIsLittleEndianBit, },
  {Feature_BPFNoMovsxBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

BPFInstructionSelector::ComplexMatcherMemFn
BPFInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

// PatFrag predicates.
bool BPFInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool BPFInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool BPFInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool BPFInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
bool BPFInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("BPFInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
};
BPFInstructionSelector::CustomRendererFn
BPFInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
};

bool BPFInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool BPFInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("BPFInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *BPFInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*    0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(248), /*)*//*default:*//*Label 22*/ GIMT_Encode4(2639),
     /*   10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(790),
     /*   14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(856),
     /*   18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(970),
     /*   22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(1036),
     /*   26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(1108),
     /*   30 */ /*TargetOpcode::G_SREM*//*Label 5*/ GIMT_Encode4(1174),
     /*   34 */ /*TargetOpcode::G_UREM*//*Label 6*/ GIMT_Encode4(1246), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   46 */ /*TargetOpcode::G_AND*//*Label 7*/ GIMT_Encode4(1312),
     /*   50 */ /*TargetOpcode::G_OR*//*Label 8*/ GIMT_Encode4(1438),
     /*   54 */ /*TargetOpcode::G_XOR*//*Label 9*/ GIMT_Encode4(1504), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 10*/ GIMT_Encode4(1570), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  330 */ /*TargetOpcode::G_ANYEXT*//*Label 11*/ GIMT_Encode4(1634),
     /*  334 */ /*TargetOpcode::G_TRUNC*//*Label 12*/ GIMT_Encode4(1697),
     /*  338 */ /*TargetOpcode::G_CONSTANT*//*Label 13*/ GIMT_Encode4(1739), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  354 */ /*TargetOpcode::G_SEXT*//*Label 14*/ GIMT_Encode4(1762),
     /*  358 */ /*TargetOpcode::G_SEXT_INREG*//*Label 15*/ GIMT_Encode4(1878),
     /*  362 */ /*TargetOpcode::G_ZEXT*//*Label 16*/ GIMT_Encode4(2074),
     /*  366 */ /*TargetOpcode::G_SHL*//*Label 17*/ GIMT_Encode4(2101),
     /*  370 */ /*TargetOpcode::G_LSHR*//*Label 18*/ GIMT_Encode4(2167),
     /*  374 */ /*TargetOpcode::G_ASHR*//*Label 19*/ GIMT_Encode4(2491), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  722 */ /*TargetOpcode::G_BR*//*Label 20*/ GIMT_Encode4(2557), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  786 */ /*TargetOpcode::G_BSWAP*//*Label 21*/ GIMT_Encode4(2573),
     /*  790 */ // Label 0: @790
     /*  790 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 25*/ GIMT_Encode4(855),
     /*  801 */ /*GILLT_s32*//*Label 23*/ GIMT_Encode4(809),
     /*  805 */ /*GILLT_s64*//*Label 24*/ GIMT_Encode4(832),
     /*  809 */ // Label 23: @809
     /*  809 */ GIM_Try, /*On fail goto*//*Label 26*/ GIMT_Encode4(831), // Rule ID 46 //
     /*  814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  817 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /*  824 */   // (add:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (ADD_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /*  824 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::ADD_rr_32),
     /*  829 */   GIR_RootConstrainSelectedInstOperands,
     /*  830 */   // GIR_Coverage, 46,
     /*  830 */   GIR_Done,
     /*  831 */ // Label 26: @831
     /*  831 */ GIM_Reject,
     /*  832 */ // Label 24: @832
     /*  832 */ GIM_Try, /*On fail goto*//*Label 27*/ GIMT_Encode4(854), // Rule ID 44 //
     /*  837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  843 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /*  847 */   // (add:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (ADD_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /*  847 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::ADD_rr),
     /*  852 */   GIR_RootConstrainSelectedInstOperands,
     /*  853 */   // GIR_Coverage, 44,
     /*  853 */   GIR_Done,
     /*  854 */ // Label 27: @854
     /*  854 */ GIM_Reject,
     /*  855 */ // Label 25: @855
     /*  855 */ GIM_Reject,
     /*  856 */ // Label 1: @856
     /*  856 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 30*/ GIMT_Encode4(969),
     /*  867 */ /*GILLT_s32*//*Label 28*/ GIMT_Encode4(875),
     /*  871 */ /*GILLT_s64*//*Label 29*/ GIMT_Encode4(922),
     /*  875 */ // Label 28: @875
     /*  875 */ GIM_Try, /*On fail goto*//*Label 31*/ GIMT_Encode4(921),
     /*  880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  883 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /*  890 */   GIM_Try, /*On fail goto*//*Label 32*/ GIMT_Encode4(908), // Rule ID 97 //
     /*  895 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  899 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, i32:{ *:[i32] }:$src)  =>  (NEG_32:{ *:[i32] } i32:{ *:[i32] }:$src)
     /*  899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::NEG_32),
     /*  902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  904 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  906 */     GIR_RootConstrainSelectedInstOperands,
     /*  907 */     // GIR_Coverage, 97,
     /*  907 */     GIR_EraseRootFromParent_Done,
     /*  908 */   // Label 32: @908
     /*  908 */   GIM_Try, /*On fail goto*//*Label 33*/ GIMT_Encode4(920), // Rule ID 50 //
     /*  913 */     // (sub:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (SUB_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /*  913 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SUB_rr_32),
     /*  918 */     GIR_RootConstrainSelectedInstOperands,
     /*  919 */     // GIR_Coverage, 50,
     /*  919 */     GIR_Done,
     /*  920 */   // Label 33: @920
     /*  920 */   GIM_Reject,
     /*  921 */ // Label 31: @921
     /*  921 */ GIM_Reject,
     /*  922 */ // Label 29: @922
     /*  922 */ GIM_Try, /*On fail goto*//*Label 34*/ GIMT_Encode4(968),
     /*  927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /*  937 */   GIM_Try, /*On fail goto*//*Label 35*/ GIMT_Encode4(955), // Rule ID 96 //
     /*  942 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  946 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, i64:{ *:[i64] }:$src)  =>  (NEG_64:{ *:[i64] } i64:{ *:[i64] }:$src)
     /*  946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::NEG_64),
     /*  949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  951 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  953 */     GIR_RootConstrainSelectedInstOperands,
     /*  954 */     // GIR_Coverage, 96,
     /*  954 */     GIR_EraseRootFromParent_Done,
     /*  955 */   // Label 35: @955
     /*  955 */   GIM_Try, /*On fail goto*//*Label 36*/ GIMT_Encode4(967), // Rule ID 48 //
     /*  960 */     // (sub:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (SUB_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /*  960 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SUB_rr),
     /*  965 */     GIR_RootConstrainSelectedInstOperands,
     /*  966 */     // GIR_Coverage, 48,
     /*  966 */     GIR_Done,
     /*  967 */   // Label 36: @967
     /*  967 */   GIM_Reject,
     /*  968 */ // Label 34: @968
     /*  968 */ GIM_Reject,
     /*  969 */ // Label 30: @969
     /*  969 */ GIM_Reject,
     /*  970 */ // Label 2: @970
     /*  970 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 39*/ GIMT_Encode4(1035),
     /*  981 */ /*GILLT_s32*//*Label 37*/ GIMT_Encode4(989),
     /*  985 */ /*GILLT_s64*//*Label 38*/ GIMT_Encode4(1012),
     /*  989 */ // Label 37: @989
     /*  989 */ GIM_Try, /*On fail goto*//*Label 40*/ GIMT_Encode4(1011), // Rule ID 78 //
     /*  994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  997 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 1000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1004 */   // (mul:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (MUL_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 1004 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::MUL_rr_32),
     /* 1009 */   GIR_RootConstrainSelectedInstOperands,
     /* 1010 */   // GIR_Coverage, 78,
     /* 1010 */   GIR_Done,
     /* 1011 */ // Label 40: @1011
     /* 1011 */ GIM_Reject,
     /* 1012 */ // Label 38: @1012
     /* 1012 */ GIM_Try, /*On fail goto*//*Label 41*/ GIMT_Encode4(1034), // Rule ID 76 //
     /* 1017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1020 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 1023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1027 */   // (mul:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (MUL_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 1027 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::MUL_rr),
     /* 1032 */   GIR_RootConstrainSelectedInstOperands,
     /* 1033 */   // GIR_Coverage, 76,
     /* 1033 */   GIR_Done,
     /* 1034 */ // Label 41: @1034
     /* 1034 */ GIM_Reject,
     /* 1035 */ // Label 39: @1035
     /* 1035 */ GIM_Reject,
     /* 1036 */ // Label 3: @1036
     /* 1036 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 44*/ GIMT_Encode4(1107),
     /* 1047 */ /*GILLT_s32*//*Label 42*/ GIMT_Encode4(1055),
     /* 1051 */ /*GILLT_s64*//*Label 43*/ GIMT_Encode4(1081),
     /* 1055 */ // Label 42: @1055
     /* 1055 */ GIM_Try, /*On fail goto*//*Label 45*/ GIMT_Encode4(1080), // Rule ID 90 //
     /* 1060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasSdivSmod),
     /* 1063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 1069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1073 */   // (sdiv:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (SDIV_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 1073 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SDIV_rr_32),
     /* 1078 */   GIR_RootConstrainSelectedInstOperands,
     /* 1079 */   // GIR_Coverage, 90,
     /* 1079 */   GIR_Done,
     /* 1080 */ // Label 45: @1080
     /* 1080 */ GIM_Reject,
     /* 1081 */ // Label 43: @1081
     /* 1081 */ GIM_Try, /*On fail goto*//*Label 46*/ GIMT_Encode4(1106), // Rule ID 88 //
     /* 1086 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasSdivSmod),
     /* 1089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1092 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 1095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1099 */   // (sdiv:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (SDIV_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 1099 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SDIV_rr),
     /* 1104 */   GIR_RootConstrainSelectedInstOperands,
     /* 1105 */   // GIR_Coverage, 88,
     /* 1105 */   GIR_Done,
     /* 1106 */ // Label 46: @1106
     /* 1106 */ GIM_Reject,
     /* 1107 */ // Label 44: @1107
     /* 1107 */ GIM_Reject,
     /* 1108 */ // Label 4: @1108
     /* 1108 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 49*/ GIMT_Encode4(1173),
     /* 1119 */ /*GILLT_s32*//*Label 47*/ GIMT_Encode4(1127),
     /* 1123 */ /*GILLT_s64*//*Label 48*/ GIMT_Encode4(1150),
     /* 1127 */ // Label 47: @1127
     /* 1127 */ GIM_Try, /*On fail goto*//*Label 50*/ GIMT_Encode4(1149), // Rule ID 82 //
     /* 1132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1135 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 1138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1142 */   // (udiv:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (DIV_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 1142 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::DIV_rr_32),
     /* 1147 */   GIR_RootConstrainSelectedInstOperands,
     /* 1148 */   // GIR_Coverage, 82,
     /* 1148 */   GIR_Done,
     /* 1149 */ // Label 50: @1149
     /* 1149 */ GIM_Reject,
     /* 1150 */ // Label 48: @1150
     /* 1150 */ GIM_Try, /*On fail goto*//*Label 51*/ GIMT_Encode4(1172), // Rule ID 80 //
     /* 1155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 1161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1165 */   // (udiv:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (DIV_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 1165 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::DIV_rr),
     /* 1170 */   GIR_RootConstrainSelectedInstOperands,
     /* 1171 */   // GIR_Coverage, 80,
     /* 1171 */   GIR_Done,
     /* 1172 */ // Label 51: @1172
     /* 1172 */ GIM_Reject,
     /* 1173 */ // Label 49: @1173
     /* 1173 */ GIM_Reject,
     /* 1174 */ // Label 5: @1174
     /* 1174 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 54*/ GIMT_Encode4(1245),
     /* 1185 */ /*GILLT_s32*//*Label 52*/ GIMT_Encode4(1193),
     /* 1189 */ /*GILLT_s64*//*Label 53*/ GIMT_Encode4(1219),
     /* 1193 */ // Label 52: @1193
     /* 1193 */ GIM_Try, /*On fail goto*//*Label 55*/ GIMT_Encode4(1218), // Rule ID 94 //
     /* 1198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasSdivSmod),
     /* 1201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1204 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 1207 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1211 */   // (srem:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (SMOD_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 1211 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SMOD_rr_32),
     /* 1216 */   GIR_RootConstrainSelectedInstOperands,
     /* 1217 */   // GIR_Coverage, 94,
     /* 1217 */   GIR_Done,
     /* 1218 */ // Label 55: @1218
     /* 1218 */ GIM_Reject,
     /* 1219 */ // Label 53: @1219
     /* 1219 */ GIM_Try, /*On fail goto*//*Label 56*/ GIMT_Encode4(1244), // Rule ID 92 //
     /* 1224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasSdivSmod),
     /* 1227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 1233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1237 */   // (srem:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (SMOD_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 1237 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SMOD_rr),
     /* 1242 */   GIR_RootConstrainSelectedInstOperands,
     /* 1243 */   // GIR_Coverage, 92,
     /* 1243 */   GIR_Done,
     /* 1244 */ // Label 56: @1244
     /* 1244 */ GIM_Reject,
     /* 1245 */ // Label 54: @1245
     /* 1245 */ GIM_Reject,
     /* 1246 */ // Label 6: @1246
     /* 1246 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 59*/ GIMT_Encode4(1311),
     /* 1257 */ /*GILLT_s32*//*Label 57*/ GIMT_Encode4(1265),
     /* 1261 */ /*GILLT_s64*//*Label 58*/ GIMT_Encode4(1288),
     /* 1265 */ // Label 57: @1265
     /* 1265 */ GIM_Try, /*On fail goto*//*Label 60*/ GIMT_Encode4(1287), // Rule ID 86 //
     /* 1270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1273 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 1276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1280 */   // (urem:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (MOD_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 1280 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::MOD_rr_32),
     /* 1285 */   GIR_RootConstrainSelectedInstOperands,
     /* 1286 */   // GIR_Coverage, 86,
     /* 1286 */   GIR_Done,
     /* 1287 */ // Label 60: @1287
     /* 1287 */ GIM_Reject,
     /* 1288 */ // Label 58: @1288
     /* 1288 */ GIM_Try, /*On fail goto*//*Label 61*/ GIMT_Encode4(1310), // Rule ID 84 //
     /* 1293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 1299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1303 */   // (urem:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (MOD_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 1303 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::MOD_rr),
     /* 1308 */   GIR_RootConstrainSelectedInstOperands,
     /* 1309 */   // GIR_Coverage, 84,
     /* 1309 */   GIR_Done,
     /* 1310 */ // Label 61: @1310
     /* 1310 */ GIM_Reject,
     /* 1311 */ // Label 59: @1311
     /* 1311 */ GIM_Reject,
     /* 1312 */ // Label 7: @1312
     /* 1312 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 64*/ GIMT_Encode4(1437),
     /* 1323 */ /*GILLT_s32*//*Label 62*/ GIMT_Encode4(1331),
     /* 1327 */ /*GILLT_s64*//*Label 63*/ GIMT_Encode4(1354),
     /* 1331 */ // Label 62: @1331
     /* 1331 */ GIM_Try, /*On fail goto*//*Label 65*/ GIMT_Encode4(1353), // Rule ID 58 //
     /* 1336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1339 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 1342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1346 */   // (and:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (AND_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 1346 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::AND_rr_32),
     /* 1351 */   GIR_RootConstrainSelectedInstOperands,
     /* 1352 */   // GIR_Coverage, 58,
     /* 1352 */   GIR_Done,
     /* 1353 */ // Label 65: @1353
     /* 1353 */ GIM_Reject,
     /* 1354 */ // Label 63: @1354
     /* 1354 */ GIM_Try, /*On fail goto*//*Label 66*/ GIMT_Encode4(1436),
     /* 1359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1362 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 1365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1369 */   GIM_Try, /*On fail goto*//*Label 67*/ GIMT_Encode4(1423), // Rule ID 171 //
     /* 1374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1378 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /* 1389 */     // (and:{ *:[i64] } GPR:{ *:[i64] }:$src, 4294967295:{ *:[i64] })  =>  (SRL_ri:{ *:[i64] } (SLL_ri:{ *:[i64] } GPR:{ *:[i64] }:$src, 32:{ *:[i64] }), 32:{ *:[i64] })
     /* 1389 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 1392 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(BPF::SLL_ri),
     /* 1396 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 1401 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 1405 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 1408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 1410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::SRL_ri),
     /* 1413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 1418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
     /* 1421 */     GIR_RootConstrainSelectedInstOperands,
     /* 1422 */     // GIR_Coverage, 171,
     /* 1422 */     GIR_EraseRootFromParent_Done,
     /* 1423 */   // Label 67: @1423
     /* 1423 */   GIM_Try, /*On fail goto*//*Label 68*/ GIMT_Encode4(1435), // Rule ID 56 //
     /* 1428 */     // (and:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (AND_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 1428 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::AND_rr),
     /* 1433 */     GIR_RootConstrainSelectedInstOperands,
     /* 1434 */     // GIR_Coverage, 56,
     /* 1434 */     GIR_Done,
     /* 1435 */   // Label 68: @1435
     /* 1435 */   GIM_Reject,
     /* 1436 */ // Label 66: @1436
     /* 1436 */ GIM_Reject,
     /* 1437 */ // Label 64: @1437
     /* 1437 */ GIM_Reject,
     /* 1438 */ // Label 8: @1438
     /* 1438 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 71*/ GIMT_Encode4(1503),
     /* 1449 */ /*GILLT_s32*//*Label 69*/ GIMT_Encode4(1457),
     /* 1453 */ /*GILLT_s64*//*Label 70*/ GIMT_Encode4(1480),
     /* 1457 */ // Label 69: @1457
     /* 1457 */ GIM_Try, /*On fail goto*//*Label 72*/ GIMT_Encode4(1479), // Rule ID 54 //
     /* 1462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1465 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 1468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1472 */   // (or:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (OR_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 1472 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::OR_rr_32),
     /* 1477 */   GIR_RootConstrainSelectedInstOperands,
     /* 1478 */   // GIR_Coverage, 54,
     /* 1478 */   GIR_Done,
     /* 1479 */ // Label 72: @1479
     /* 1479 */ GIM_Reject,
     /* 1480 */ // Label 70: @1480
     /* 1480 */ GIM_Try, /*On fail goto*//*Label 73*/ GIMT_Encode4(1502), // Rule ID 52 //
     /* 1485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1488 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 1491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1495 */   // (or:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (OR_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 1495 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::OR_rr),
     /* 1500 */   GIR_RootConstrainSelectedInstOperands,
     /* 1501 */   // GIR_Coverage, 52,
     /* 1501 */   GIR_Done,
     /* 1502 */ // Label 73: @1502
     /* 1502 */ GIM_Reject,
     /* 1503 */ // Label 71: @1503
     /* 1503 */ GIM_Reject,
     /* 1504 */ // Label 9: @1504
     /* 1504 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 76*/ GIMT_Encode4(1569),
     /* 1515 */ /*GILLT_s32*//*Label 74*/ GIMT_Encode4(1523),
     /* 1519 */ /*GILLT_s64*//*Label 75*/ GIMT_Encode4(1546),
     /* 1523 */ // Label 74: @1523
     /* 1523 */ GIM_Try, /*On fail goto*//*Label 77*/ GIMT_Encode4(1545), // Rule ID 70 //
     /* 1528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1531 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 1534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1538 */   // (xor:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (XOR_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 1538 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::XOR_rr_32),
     /* 1543 */   GIR_RootConstrainSelectedInstOperands,
     /* 1544 */   // GIR_Coverage, 70,
     /* 1544 */   GIR_Done,
     /* 1545 */ // Label 77: @1545
     /* 1545 */ GIM_Reject,
     /* 1546 */ // Label 75: @1546
     /* 1546 */ GIM_Try, /*On fail goto*//*Label 78*/ GIMT_Encode4(1568), // Rule ID 68 //
     /* 1551 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1554 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 1557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1561 */   // (xor:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (XOR_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 1561 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::XOR_rr),
     /* 1566 */   GIR_RootConstrainSelectedInstOperands,
     /* 1567 */   // GIR_Coverage, 68,
     /* 1567 */   GIR_Done,
     /* 1568 */ // Label 78: @1568
     /* 1568 */ GIM_Reject,
     /* 1569 */ // Label 76: @1569
     /* 1569 */ GIM_Reject,
     /* 1570 */ // Label 10: @1570
     /* 1570 */ GIM_Try, /*On fail goto*//*Label 79*/ GIMT_Encode4(1633), // Rule ID 107 //
     /* 1575 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 1578 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::bpf_pseudo),
     /* 1583 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 1586 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 1589 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 1592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1596 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 1600 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1604 */   // MIs[1] Operand 1
     /* 1604 */   // No operand predicates
     /* 1604 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 1608 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 1612 */   // MIs[2] Operand 1
     /* 1612 */   // No operand predicates
     /* 1612 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 1614 */   // (intrinsic_w_chain:{ *:[i64] } 3932:{ *:[iPTR] }, (imm:{ *:[i64] }):$pseudo, (imm:{ *:[i64] }):$imm)  =>  (LD_pseudo:{ *:[i64] } (imm:{ *:[i64] }):$pseudo, (imm:{ *:[i64] }):$imm)
     /* 1614 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::LD_pseudo),
     /* 1617 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1619 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pseudo
     /* 1622 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 1625 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 1631 */   GIR_RootConstrainSelectedInstOperands,
     /* 1632 */   // GIR_Coverage, 107,
     /* 1632 */   GIR_EraseRootFromParent_Done,
     /* 1633 */ // Label 79: @1633
     /* 1633 */ GIM_Reject,
     /* 1634 */ // Label 11: @1634
     /* 1634 */ GIM_Try, /*On fail goto*//*Label 80*/ GIMT_Encode4(1696), // Rule ID 238 //
     /* 1639 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 1642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1649 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1653 */   // (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] })
     /* 1653 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 1656 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 1660 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 1665 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 1667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 1670 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1672 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 1675 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 1677 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 1680 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(BPF::GPRRegClassID),
     /* 1685 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(BPF::GPRRegClassID),
     /* 1690 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1695 */   // GIR_Coverage, 238,
     /* 1695 */   GIR_EraseRootFromParent_Done,
     /* 1696 */ // Label 80: @1696
     /* 1696 */ GIM_Reject,
     /* 1697 */ // Label 12: @1697
     /* 1697 */ GIM_Try, /*On fail goto*//*Label 81*/ GIMT_Encode4(1738), // Rule ID 237 //
     /* 1702 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 1705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1716 */   // (trunc:{ *:[i32] } GPR:{ *:[i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i32] } GPR:{ *:[i64] }:$src, sub_32:{ *:[i32] })
     /* 1716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 1719 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1721 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 1727 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1732 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(BPF::GPRRegClassID),
     /* 1737 */   // GIR_Coverage, 237,
     /* 1737 */   GIR_EraseRootFromParent_Done,
     /* 1738 */ // Label 81: @1738
     /* 1738 */ GIM_Reject,
     /* 1739 */ // Label 13: @1739
     /* 1739 */ GIM_Try, /*On fail goto*//*Label 82*/ GIMT_Encode4(1761), // Rule ID 98 //
     /* 1744 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 1747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1751 */   // MIs[0] Operand 1
     /* 1751 */   // No operand predicates
     /* 1751 */   // (imm:{ *:[i64] }):$imm  =>  (LD_imm64:{ *:[i64] } (imm:{ *:[i64] }):$imm)
     /* 1751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::LD_imm64),
     /* 1754 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1756 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /* 1759 */   GIR_RootConstrainSelectedInstOperands,
     /* 1760 */   // GIR_Coverage, 98,
     /* 1760 */   GIR_EraseRootFromParent_Done,
     /* 1761 */ // Label 82: @1761
     /* 1761 */ GIM_Reject,
     /* 1762 */ // Label 14: @1762
     /* 1762 */ GIM_Try, /*On fail goto*//*Label 83*/ GIMT_Encode4(1877),
     /* 1767 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 1770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1777 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1781 */   GIM_Try, /*On fail goto*//*Label 84*/ GIMT_Encode4(1840), // Rule ID 234 //
     /* 1786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFNoMovsx),
     /* 1789 */     // (sext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (SRA_ri:{ *:[i64] } (SLL_ri:{ *:[i64] } (MOV_32_64:{ *:[i64] } GPR32:{ *:[i32] }:$src), 32:{ *:[i64] }), 32:{ *:[i64] })
     /* 1789 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 1792 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(BPF::MOV_32_64),
     /* 1796 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 1801 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 1805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 1807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 1810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(BPF::SLL_ri),
     /* 1814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 1819 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 1822 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 1825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 1827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::SRA_ri),
     /* 1830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 1835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/32,
     /* 1838 */     GIR_RootConstrainSelectedInstOperands,
     /* 1839 */     // GIR_Coverage, 234,
     /* 1839 */     GIR_EraseRootFromParent_Done,
     /* 1840 */   // Label 84: @1840
     /* 1840 */   GIM_Try, /*On fail goto*//*Label 85*/ GIMT_Encode4(1876), // Rule ID 235 //
     /* 1845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasMovsx),
     /* 1848 */     // (sext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (MOVSX_rr_32:{ *:[i64] } (MOV_32_64:{ *:[i64] } GPR32:{ *:[i32] }:$src))
     /* 1848 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 1851 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(BPF::MOV_32_64),
     /* 1855 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 1860 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 1864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 1866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::MOVSX_rr_32),
     /* 1869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1871 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 1874 */     GIR_RootConstrainSelectedInstOperands,
     /* 1875 */     // GIR_Coverage, 235,
     /* 1875 */     GIR_EraseRootFromParent_Done,
     /* 1876 */   // Label 85: @1876
     /* 1876 */   GIM_Reject,
     /* 1877 */ // Label 83: @1877
     /* 1877 */ GIM_Reject,
     /* 1878 */ // Label 15: @1878
     /* 1878 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 88*/ GIMT_Encode4(2073),
     /* 1889 */ /*GILLT_s32*//*Label 86*/ GIMT_Encode4(1897),
     /* 1893 */ /*GILLT_s64*//*Label 87*/ GIMT_Encode4(1971),
     /* 1897 */ // Label 86: @1897
     /* 1897 */ GIM_Try, /*On fail goto*//*Label 89*/ GIMT_Encode4(1970),
     /* 1902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 1905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 1913 */   GIM_Try, /*On fail goto*//*Label 90*/ GIMT_Encode4(1941), // Rule ID 104 //
     /* 1918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasMovsx),
     /* 1921 */     // MIs[0] Operand 2
     /* 1921 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 1932 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i8:{ *:[Other] })  =>  (MOVSX_rr_32_8:{ *:[i32] } GPR32:{ *:[i32] }:$src)
     /* 1932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::MOVSX_rr_32_8),
     /* 1935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1937 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 1939 */     GIR_RootConstrainSelectedInstOperands,
     /* 1940 */     // GIR_Coverage, 104,
     /* 1940 */     GIR_EraseRootFromParent_Done,
     /* 1941 */   // Label 90: @1941
     /* 1941 */   GIM_Try, /*On fail goto*//*Label 91*/ GIMT_Encode4(1969), // Rule ID 105 //
     /* 1946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasMovsx),
     /* 1949 */     // MIs[0] Operand 2
     /* 1949 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 1960 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i16:{ *:[Other] })  =>  (MOVSX_rr_32_16:{ *:[i32] } GPR32:{ *:[i32] }:$src)
     /* 1960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::MOVSX_rr_32_16),
     /* 1963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 1965 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 1967 */     GIR_RootConstrainSelectedInstOperands,
     /* 1968 */     // GIR_Coverage, 105,
     /* 1968 */     GIR_EraseRootFromParent_Done,
     /* 1969 */   // Label 91: @1969
     /* 1969 */   GIM_Reject,
     /* 1970 */ // Label 89: @1970
     /* 1970 */ GIM_Reject,
     /* 1971 */ // Label 87: @1971
     /* 1971 */ GIM_Try, /*On fail goto*//*Label 92*/ GIMT_Encode4(2072),
     /* 1976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 1979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 1987 */   GIM_Try, /*On fail goto*//*Label 93*/ GIMT_Encode4(2015), // Rule ID 101 //
     /* 1992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasMovsx),
     /* 1995 */     // MIs[0] Operand 2
     /* 1995 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 2006 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$src, i8:{ *:[Other] })  =>  (MOVSX_rr_8:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::MOVSX_rr_8),
     /* 2009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2011 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 2013 */     GIR_RootConstrainSelectedInstOperands,
     /* 2014 */     // GIR_Coverage, 101,
     /* 2014 */     GIR_EraseRootFromParent_Done,
     /* 2015 */   // Label 93: @2015
     /* 2015 */   GIM_Try, /*On fail goto*//*Label 94*/ GIMT_Encode4(2043), // Rule ID 102 //
     /* 2020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasMovsx),
     /* 2023 */     // MIs[0] Operand 2
     /* 2023 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 2034 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$src, i16:{ *:[Other] })  =>  (MOVSX_rr_16:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::MOVSX_rr_16),
     /* 2037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2039 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 2041 */     GIR_RootConstrainSelectedInstOperands,
     /* 2042 */     // GIR_Coverage, 102,
     /* 2042 */     GIR_EraseRootFromParent_Done,
     /* 2043 */   // Label 94: @2043
     /* 2043 */   GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(2071), // Rule ID 103 //
     /* 2048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasMovsx),
     /* 2051 */     // MIs[0] Operand 2
     /* 2051 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 2062 */     // (sext_inreg:{ *:[i64] } GPR:{ *:[i64] }:$src, i32:{ *:[Other] })  =>  (MOVSX_rr_32:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::MOVSX_rr_32),
     /* 2065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2067 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 2069 */     GIR_RootConstrainSelectedInstOperands,
     /* 2070 */     // GIR_Coverage, 103,
     /* 2070 */     GIR_EraseRootFromParent_Done,
     /* 2071 */   // Label 95: @2071
     /* 2071 */   GIM_Reject,
     /* 2072 */ // Label 92: @2072
     /* 2072 */ GIM_Reject,
     /* 2073 */ // Label 88: @2073
     /* 2073 */ GIM_Reject,
     /* 2074 */ // Label 16: @2074
     /* 2074 */ GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(2100), // Rule ID 236 //
     /* 2079 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 2093 */   // (zext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (MOV_32_64:{ *:[i64] } GPR32:{ *:[i32] }:$src)
     /* 2093 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::MOV_32_64),
     /* 2098 */   GIR_RootConstrainSelectedInstOperands,
     /* 2099 */   // GIR_Coverage, 236,
     /* 2099 */   GIR_Done,
     /* 2100 */ // Label 96: @2100
     /* 2100 */ GIM_Reject,
     /* 2101 */ // Label 17: @2101
     /* 2101 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 99*/ GIMT_Encode4(2166),
     /* 2112 */ /*GILLT_s32*//*Label 97*/ GIMT_Encode4(2120),
     /* 2116 */ /*GILLT_s64*//*Label 98*/ GIMT_Encode4(2143),
     /* 2120 */ // Label 97: @2120
     /* 2120 */ GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(2142), // Rule ID 62 //
     /* 2125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 2135 */   // (shl:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (SLL_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 2135 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SLL_rr_32),
     /* 2140 */   GIR_RootConstrainSelectedInstOperands,
     /* 2141 */   // GIR_Coverage, 62,
     /* 2141 */   GIR_Done,
     /* 2142 */ // Label 100: @2142
     /* 2142 */ GIM_Reject,
     /* 2143 */ // Label 98: @2143
     /* 2143 */ GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(2165), // Rule ID 60 //
     /* 2148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2151 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2158 */   // (shl:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (SLL_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 2158 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SLL_rr),
     /* 2163 */   GIR_RootConstrainSelectedInstOperands,
     /* 2164 */   // GIR_Coverage, 60,
     /* 2164 */   GIR_Done,
     /* 2165 */ // Label 101: @2165
     /* 2165 */ GIM_Reject,
     /* 2166 */ // Label 99: @2166
     /* 2166 */ GIM_Reject,
     /* 2167 */ // Label 18: @2167
     /* 2167 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 104*/ GIMT_Encode4(2490),
     /* 2178 */ /*GILLT_s32*//*Label 102*/ GIMT_Encode4(2186),
     /* 2182 */ /*GILLT_s64*//*Label 103*/ GIMT_Encode4(2209),
     /* 2186 */ // Label 102: @2186
     /* 2186 */ GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(2208), // Rule ID 66 //
     /* 2191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2194 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 2201 */   // (srl:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (SRL_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 2201 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SRL_rr_32),
     /* 2206 */   GIR_RootConstrainSelectedInstOperands,
     /* 2207 */   // GIR_Coverage, 66,
     /* 2207 */   GIR_Done,
     /* 2208 */ // Label 105: @2208
     /* 2208 */ GIM_Reject,
     /* 2209 */ // Label 103: @2209
     /* 2209 */ GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(2489),
     /* 2214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2217 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2220 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2224 */   GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(2266), // Rule ID 139 //
     /* 2229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasBswap),
     /* 2232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2249 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 48,
     /* 2253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2255 */     // (srl:{ *:[i64] } (bswap:{ *:[i64] } GPR:{ *:[i64] }:$src), 48:{ *:[i64] })  =>  (BSWAP16:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::BSWAP16),
     /* 2258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 2264 */     GIR_RootConstrainSelectedInstOperands,
     /* 2265 */     // GIR_Coverage, 139,
     /* 2265 */     GIR_EraseRootFromParent_Done,
     /* 2266 */   // Label 107: @2266
     /* 2266 */   GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(2308), // Rule ID 140 //
     /* 2271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasBswap),
     /* 2274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2286 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2291 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 2295 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2297 */     // (srl:{ *:[i64] } (bswap:{ *:[i64] } GPR:{ *:[i64] }:$src), 32:{ *:[i64] })  =>  (BSWAP32:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::BSWAP32),
     /* 2300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 2306 */     GIR_RootConstrainSelectedInstOperands,
     /* 2307 */     // GIR_Coverage, 140,
     /* 2307 */     GIR_EraseRootFromParent_Done,
     /* 2308 */   // Label 108: @2308
     /* 2308 */   GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(2350), // Rule ID 142 //
     /* 2313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFIsLittleEndian),
     /* 2316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2333 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 48,
     /* 2337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2339 */     // (srl:{ *:[i64] } (bswap:{ *:[i64] } GPR:{ *:[i64] }:$src), 48:{ *:[i64] })  =>  (BE16:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::BE16),
     /* 2342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 2348 */     GIR_RootConstrainSelectedInstOperands,
     /* 2349 */     // GIR_Coverage, 142,
     /* 2349 */     GIR_EraseRootFromParent_Done,
     /* 2350 */   // Label 109: @2350
     /* 2350 */   GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(2392), // Rule ID 143 //
     /* 2355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFIsLittleEndian),
     /* 2358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2375 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 2379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2381 */     // (srl:{ *:[i64] } (bswap:{ *:[i64] } GPR:{ *:[i64] }:$src), 32:{ *:[i64] })  =>  (BE32:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::BE32),
     /* 2384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 2390 */     GIR_RootConstrainSelectedInstOperands,
     /* 2391 */     // GIR_Coverage, 143,
     /* 2391 */     GIR_EraseRootFromParent_Done,
     /* 2392 */   // Label 110: @2392
     /* 2392 */   GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(2434), // Rule ID 145 //
     /* 2397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFIsBigEndian),
     /* 2400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2417 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 48,
     /* 2421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2423 */     // (srl:{ *:[i64] } (bswap:{ *:[i64] } GPR:{ *:[i64] }:$src), 48:{ *:[i64] })  =>  (LE16:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::LE16),
     /* 2426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 2432 */     GIR_RootConstrainSelectedInstOperands,
     /* 2433 */     // GIR_Coverage, 145,
     /* 2433 */     GIR_EraseRootFromParent_Done,
     /* 2434 */   // Label 111: @2434
     /* 2434 */   GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(2476), // Rule ID 146 //
     /* 2439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFIsBigEndian),
     /* 2442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 2446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 2450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 2454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2459 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 2463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 2465 */     // (srl:{ *:[i64] } (bswap:{ *:[i64] } GPR:{ *:[i64] }:$src), 32:{ *:[i64] })  =>  (LE32:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(BPF::LE32),
     /* 2468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 2470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src
     /* 2474 */     GIR_RootConstrainSelectedInstOperands,
     /* 2475 */     // GIR_Coverage, 146,
     /* 2475 */     GIR_EraseRootFromParent_Done,
     /* 2476 */   // Label 112: @2476
     /* 2476 */   GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(2488), // Rule ID 64 //
     /* 2481 */     // (srl:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (SRL_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 2481 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SRL_rr),
     /* 2486 */     GIR_RootConstrainSelectedInstOperands,
     /* 2487 */     // GIR_Coverage, 64,
     /* 2487 */     GIR_Done,
     /* 2488 */   // Label 113: @2488
     /* 2488 */   GIM_Reject,
     /* 2489 */ // Label 106: @2489
     /* 2489 */ GIM_Reject,
     /* 2490 */ // Label 104: @2490
     /* 2490 */ GIM_Reject,
     /* 2491 */ // Label 19: @2491
     /* 2491 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(2), /*)*//*default:*//*Label 116*/ GIMT_Encode4(2556),
     /* 2502 */ /*GILLT_s32*//*Label 114*/ GIMT_Encode4(2510),
     /* 2506 */ /*GILLT_s64*//*Label 115*/ GIMT_Encode4(2533),
     /* 2510 */ // Label 114: @2510
     /* 2510 */ GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(2532), // Rule ID 74 //
     /* 2515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 2518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 2521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPR32RegClassID),
     /* 2525 */   // (sra:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)  =>  (SRA_rr_32:{ *:[i32] } i32:{ *:[i32] }:$src2, i32:{ *:[i32] }:$src)
     /* 2525 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SRA_rr_32),
     /* 2530 */   GIR_RootConstrainSelectedInstOperands,
     /* 2531 */   // GIR_Coverage, 74,
     /* 2531 */   GIR_Done,
     /* 2532 */ // Label 117: @2532
     /* 2532 */ GIM_Reject,
     /* 2533 */ // Label 115: @2533
     /* 2533 */ GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(2555), // Rule ID 72 //
     /* 2538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 2544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2548 */   // (sra:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)  =>  (SRA_rr:{ *:[i64] } i64:{ *:[i64] }:$src2, i64:{ *:[i64] }:$src)
     /* 2548 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::SRA_rr),
     /* 2553 */   GIR_RootConstrainSelectedInstOperands,
     /* 2554 */   // GIR_Coverage, 72,
     /* 2554 */   GIR_Done,
     /* 2555 */ // Label 118: @2555
     /* 2555 */ GIM_Reject,
     /* 2556 */ // Label 116: @2556
     /* 2556 */ GIM_Reject,
     /* 2557 */ // Label 20: @2557
     /* 2557 */ GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(2572), // Rule ID 123 //
     /* 2562 */   // MIs[0] BrDst
     /* 2562 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 2565 */   // (br (bb:{ *:[Other] }):$BrDst)  =>  (JMP (bb:{ *:[Other] }):$BrDst)
     /* 2565 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::JMP),
     /* 2570 */   GIR_RootConstrainSelectedInstOperands,
     /* 2571 */   // GIR_Coverage, 123,
     /* 2571 */   GIR_Done,
     /* 2572 */ // Label 119: @2572
     /* 2572 */ GIM_Reject,
     /* 2573 */ // Label 21: @2573
     /* 2573 */ GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(2638),
     /* 2578 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 2581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 2584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(BPF::GPRRegClassID),
     /* 2592 */   GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(2607), // Rule ID 141 //
     /* 2597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFHasBswap),
     /* 2600 */     // (bswap:{ *:[i64] } GPR:{ *:[i64] }:$src)  =>  (BSWAP64:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2600 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::BSWAP64),
     /* 2605 */     GIR_RootConstrainSelectedInstOperands,
     /* 2606 */     // GIR_Coverage, 141,
     /* 2606 */     GIR_Done,
     /* 2607 */   // Label 121: @2607
     /* 2607 */   GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(2622), // Rule ID 144 //
     /* 2612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFIsLittleEndian),
     /* 2615 */     // (bswap:{ *:[i64] } GPR:{ *:[i64] }:$src)  =>  (BE64:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2615 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::BE64),
     /* 2620 */     GIR_RootConstrainSelectedInstOperands,
     /* 2621 */     // GIR_Coverage, 144,
     /* 2621 */     GIR_Done,
     /* 2622 */   // Label 122: @2622
     /* 2622 */   GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(2637), // Rule ID 147 //
     /* 2627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_BPFIsBigEndian),
     /* 2630 */     // (bswap:{ *:[i64] } GPR:{ *:[i64] }:$src)  =>  (LE64:{ *:[i64] } GPR:{ *:[i64] }:$src)
     /* 2630 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(BPF::LE64),
     /* 2635 */     GIR_RootConstrainSelectedInstOperands,
     /* 2636 */     // GIR_Coverage, 147,
     /* 2636 */     GIR_Done,
     /* 2637 */   // Label 123: @2637
     /* 2637 */   GIM_Reject,
     /* 2638 */ // Label 120: @2638
     /* 2638 */ GIM_Reject,
     /* 2639 */ // Label 22: @2639
     /* 2639 */ GIM_Reject,
     /* 2640 */ }; // Size: 2640 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const BPFSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const BPFSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
